/* game-board-view.c generated by valac 0.56.3, the Vala compiler
 * generated from game-board-view.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
   This file is part of GNOME Four-in-a-row.

   Copyright © 2018 Jacob Humphrey

   GNOME Four-in-a-row is free software: you can redistribute it and/or
   modify it under the terms of the GNU General Public License as published
   by the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   GNOME Four-in-a-row is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with GNOME Four-in-a-row.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gdk/gdk.h>
#include <cairo-gobject.h>
#include <float.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_GAME_BOARD_VIEW (game_board_view_get_type ())
#define GAME_BOARD_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_BOARD_VIEW, GameBoardView))
#define GAME_BOARD_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_BOARD_VIEW, GameBoardViewClass))
#define IS_GAME_BOARD_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_BOARD_VIEW))
#define IS_GAME_BOARD_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_BOARD_VIEW))
#define GAME_BOARD_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_BOARD_VIEW, GameBoardViewClass))

typedef struct _GameBoardView GameBoardView;
typedef struct _GameBoardViewClass GameBoardViewClass;
typedef struct _GameBoardViewPrivate GameBoardViewPrivate;

#define TYPE_BOARD (board_get_type ())
#define BOARD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BOARD, Board))
#define BOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BOARD, BoardClass))
#define IS_BOARD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BOARD))
#define IS_BOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BOARD))
#define BOARD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BOARD, BoardClass))

typedef struct _Board Board;
typedef struct _BoardClass BoardClass;

#define TYPE_THEME_MANAGER (theme_manager_get_type ())
#define THEME_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THEME_MANAGER, ThemeManager))
#define THEME_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THEME_MANAGER, ThemeManagerClass))
#define IS_THEME_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THEME_MANAGER))
#define IS_THEME_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THEME_MANAGER))
#define THEME_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THEME_MANAGER, ThemeManagerClass))

typedef struct _ThemeManager ThemeManager;
typedef struct _ThemeManagerClass ThemeManagerClass;
enum  {
	GAME_BOARD_VIEW_0_PROPERTY,
	GAME_BOARD_VIEW_GAME_BOARD_PROPERTY,
	GAME_BOARD_VIEW_THEME_MANAGER_PROPERTY,
	GAME_BOARD_VIEW_NUM_PROPERTIES
};
static GParamSpec* game_board_view_properties[GAME_BOARD_VIEW_NUM_PROPERTIES];
typedef enum  {
	GAME_BOARD_VIEW_TILE_PLAYER1,
	GAME_BOARD_VIEW_TILE_PLAYER2,
	GAME_BOARD_VIEW_TILE_CLEAR,
	GAME_BOARD_VIEW_TILE_CLEAR_CURSOR,
	GAME_BOARD_VIEW_TILE_PLAYER1_CURSOR,
	GAME_BOARD_VIEW_TILE_PLAYER2_CURSOR
} GameBoardViewTile;

#define GAME_BOARD_VIEW_TYPE_TILE (game_board_view_tile_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef enum  {
	PLAYER_NOBODY,
	PLAYER_HUMAN,
	PLAYER_OPPONENT
} Player;

#define TYPE_PLAYER (player_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_GdkEvent_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkEvent_free (var), NULL)))
enum  {
	GAME_BOARD_VIEW_COLUMN_CLICKED_SIGNAL,
	GAME_BOARD_VIEW_NUM_SIGNALS
};
static guint game_board_view_signals[GAME_BOARD_VIEW_NUM_SIGNALS] = {0};

struct _GameBoardView {
	GtkDrawingArea parent_instance;
	GameBoardViewPrivate * priv;
};

struct _GameBoardViewClass {
	GtkDrawingAreaClass parent_class;
};

struct _GameBoardViewPrivate {
	Board* _game_board;
	ThemeManager* _theme_manager;
	gint board_size;
	gint tile_size;
	gint offset[6];
	gint board_x;
	gint board_y;
	GdkPixbuf* pb_tileset;
	GdkPixbuf* pb_bground;
	GtkGestureMultiPress* click_controller;
};

static gint GameBoardView_private_offset;
static gpointer game_board_view_parent_class = NULL;

VALA_EXTERN GType game_board_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameBoardView, g_object_unref)
VALA_EXTERN GType board_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Board, g_object_unref)
VALA_EXTERN GType theme_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ThemeManager, g_object_unref)
static GType game_board_view_tile_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
VALA_EXTERN GameBoardView* game_board_view_new (Board* game_board,
                                    ThemeManager* theme_manager);
VALA_EXTERN GameBoardView* game_board_view_construct (GType object_type,
                                          Board* game_board,
                                          ThemeManager* theme_manager);
VALA_EXTERN void game_board_view_draw_tile (GameBoardView* self,
                                gint row,
                                gint col);
static gboolean game_board_view_real_configure_event (GtkWidget* base,
                                               GdkEventConfigure* e);
static Board* game_board_view_get_game_board (GameBoardView* self);
VALA_EXTERN guint8 board_get_size (Board* self);
static void game_board_view_refresh_pixmaps (GameBoardView* self);
static gboolean game_board_view_real_draw (GtkWidget* base,
                                    cairo_t* cr);
static inline void game_board_view_paint_tile (GameBoardView* self,
                                 cairo_t* cr,
                                 guint8 row,
                                 guint8 col);
static inline void game_board_view_draw_grid (GameBoardView* self,
                                cairo_t* cr);
VALA_EXTERN GType player_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Player board_get (Board* self,
                  guint8 x,
                  guint8 y);
static ThemeManager* game_board_view_get_theme_manager (GameBoardView* self);
VALA_EXTERN gchar* theme_manager_get_grid_color (ThemeManager* self);
VALA_EXTERN GdkPixbuf* theme_manager_get_pb_tileset_raw (ThemeManager* self);
VALA_EXTERN GdkPixbuf* theme_manager_get_pb_bground_raw (ThemeManager* self);
static inline void game_board_view_init_mouse (GameBoardView* self);
static inline void game_board_view_on_click (GameBoardView* self,
                               GtkGestureMultiPress* _click_controller,
                               gint n_press,
                               gdouble event_x,
                               gdouble event_y);
static void _game_board_view_on_click_gtk_gesture_multi_press_pressed (GtkGestureMultiPress* _sender,
                                                                gint n_press,
                                                                gdouble x,
                                                                gdouble y,
                                                                gpointer self);
static inline gboolean game_board_view_get_column (GameBoardView* self,
                                     gint x,
                                     gint y,
                                     guint8* col);
static void _vala_GdkEvent_free (GdkEvent* self);
static void game_board_view_set_game_board (GameBoardView* self,
                                     Board* value);
static void game_board_view_set_theme_manager (GameBoardView* self,
                                        ThemeManager* value);
static void g_cclosure_user_marshal_BOOLEAN__UCHAR (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data);
static GObject * game_board_view_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void _game_board_view_refresh_pixmaps_theme_manager_theme_changed (ThemeManager* _sender,
                                                                   gpointer self);
static void game_board_view_finalize (GObject * obj);
static GType game_board_view_get_type_once (void);
static void _vala_game_board_view_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_game_board_view_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);

static inline gpointer
game_board_view_get_instance_private (GameBoardView* self)
{
	return G_STRUCT_MEMBER_P (self, GameBoardView_private_offset);
}

static GType
game_board_view_tile_get_type_once (void)
{
	static const GEnumValue values[] = {{GAME_BOARD_VIEW_TILE_PLAYER1, "GAME_BOARD_VIEW_TILE_PLAYER1", "player1"}, {GAME_BOARD_VIEW_TILE_PLAYER2, "GAME_BOARD_VIEW_TILE_PLAYER2", "player2"}, {GAME_BOARD_VIEW_TILE_CLEAR, "GAME_BOARD_VIEW_TILE_CLEAR", "clear"}, {GAME_BOARD_VIEW_TILE_CLEAR_CURSOR, "GAME_BOARD_VIEW_TILE_CLEAR_CURSOR", "clear-cursor"}, {GAME_BOARD_VIEW_TILE_PLAYER1_CURSOR, "GAME_BOARD_VIEW_TILE_PLAYER1_CURSOR", "player1-cursor"}, {GAME_BOARD_VIEW_TILE_PLAYER2_CURSOR, "GAME_BOARD_VIEW_TILE_PLAYER2_CURSOR", "player2-cursor"}, {0, NULL, NULL}};
	GType game_board_view_tile_type_id;
	game_board_view_tile_type_id = g_enum_register_static ("GameBoardViewTile", values);
	return game_board_view_tile_type_id;
}

static GType
game_board_view_tile_get_type (void)
{
	static volatile gsize game_board_view_tile_type_id__once = 0;
	if (g_once_init_enter (&game_board_view_tile_type_id__once)) {
		GType game_board_view_tile_type_id;
		game_board_view_tile_type_id = game_board_view_tile_get_type_once ();
		g_once_init_leave (&game_board_view_tile_type_id__once, game_board_view_tile_type_id);
	}
	return game_board_view_tile_type_id__once;
}

GameBoardView*
game_board_view_construct (GType object_type,
                           Board* game_board,
                           ThemeManager* theme_manager)
{
	GameBoardView * self = NULL;
#line 35 "../src/game-board-view.vala"
	g_return_val_if_fail (game_board != NULL, NULL);
#line 35 "../src/game-board-view.vala"
	g_return_val_if_fail (theme_manager != NULL, NULL);
#line 37 "../src/game-board-view.vala"
	self = (GameBoardView*) g_object_new (object_type, "game-board", game_board, "theme-manager", theme_manager, NULL);
#line 35 "../src/game-board-view.vala"
	return self;
#line 253 "game-board-view.c"
}

GameBoardView*
game_board_view_new (Board* game_board,
                     ThemeManager* theme_manager)
{
#line 35 "../src/game-board-view.vala"
	return game_board_view_construct (TYPE_GAME_BOARD_VIEW, game_board, theme_manager);
#line 262 "game-board-view.c"
}

inline void
game_board_view_draw_tile (GameBoardView* self,
                           gint row,
                           gint col)
{
#line 60 "../src/game-board-view.vala"
	g_return_if_fail (self != NULL);
#line 62 "../src/game-board-view.vala"
	gtk_widget_queue_draw_area ((GtkWidget*) self, (col * self->priv->tile_size) + self->priv->board_x, (row * self->priv->tile_size) + self->priv->board_y, self->priv->tile_size, self->priv->tile_size);
#line 274 "game-board-view.c"
}

static gboolean
game_board_view_real_configure_event (GtkWidget* base,
                                      GdkEventConfigure* e)
{
	GameBoardView * self;
	gint allocated_width = 0;
	gint allocated_height = 0;
	gint size = 0;
	Board* _tmp0_;
	guint8 _tmp1_;
	guint8 _tmp2_;
	Board* _tmp3_;
	guint8 _tmp4_;
	guint8 _tmp5_;
	gboolean result;
#line 68 "../src/game-board-view.vala"
	self = (GameBoardView*) base;
#line 68 "../src/game-board-view.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 70 "../src/game-board-view.vala"
	allocated_width = gtk_widget_get_allocated_width ((GtkWidget*) self);
#line 71 "../src/game-board-view.vala"
	allocated_height = gtk_widget_get_allocated_height ((GtkWidget*) self);
#line 72 "../src/game-board-view.vala"
	size = MIN (allocated_width, allocated_height);
#line 73 "../src/game-board-view.vala"
	_tmp0_ = self->priv->_game_board;
#line 73 "../src/game-board-view.vala"
	_tmp1_ = board_get_size (_tmp0_);
#line 73 "../src/game-board-view.vala"
	_tmp2_ = _tmp1_;
#line 73 "../src/game-board-view.vala"
	self->priv->tile_size = size / _tmp2_;
#line 74 "../src/game-board-view.vala"
	_tmp3_ = self->priv->_game_board;
#line 74 "../src/game-board-view.vala"
	_tmp4_ = board_get_size (_tmp3_);
#line 74 "../src/game-board-view.vala"
	_tmp5_ = _tmp4_;
#line 74 "../src/game-board-view.vala"
	self->priv->board_size = self->priv->tile_size * _tmp5_;
#line 75 "../src/game-board-view.vala"
	self->priv->board_x = (allocated_width - self->priv->board_size) / 2;
#line 76 "../src/game-board-view.vala"
	self->priv->board_y = (allocated_height - self->priv->board_size) / 2;
#line 78 "../src/game-board-view.vala"
	self->priv->offset[GAME_BOARD_VIEW_TILE_PLAYER1] = 0;
#line 79 "../src/game-board-view.vala"
	self->priv->offset[GAME_BOARD_VIEW_TILE_PLAYER2] = self->priv->tile_size;
#line 80 "../src/game-board-view.vala"
	self->priv->offset[GAME_BOARD_VIEW_TILE_CLEAR] = self->priv->tile_size * 2;
#line 81 "../src/game-board-view.vala"
	self->priv->offset[GAME_BOARD_VIEW_TILE_CLEAR_CURSOR] = self->priv->tile_size * 3;
#line 82 "../src/game-board-view.vala"
	self->priv->offset[GAME_BOARD_VIEW_TILE_PLAYER1_CURSOR] = self->priv->tile_size * 4;
#line 83 "../src/game-board-view.vala"
	self->priv->offset[GAME_BOARD_VIEW_TILE_PLAYER2_CURSOR] = self->priv->tile_size * 5;
#line 85 "../src/game-board-view.vala"
	game_board_view_refresh_pixmaps (self);
#line 86 "../src/game-board-view.vala"
	result = TRUE;
#line 86 "../src/game-board-view.vala"
	return result;
#line 340 "game-board-view.c"
}

static gboolean
game_board_view_real_draw (GtkWidget* base,
                           cairo_t* cr)
{
	GameBoardView * self;
	GdkPixbuf* _tmp0_;
	gboolean result;
#line 93 "../src/game-board-view.vala"
	self = (GameBoardView*) base;
#line 93 "../src/game-board-view.vala"
	g_return_val_if_fail (cr != NULL, FALSE);
#line 96 "../src/game-board-view.vala"
	cairo_save (cr);
#line 97 "../src/game-board-view.vala"
	cairo_translate (cr, (gdouble) self->priv->board_x, (gdouble) self->priv->board_y);
#line 98 "../src/game-board-view.vala"
	_tmp0_ = self->priv->pb_bground;
#line 98 "../src/game-board-view.vala"
	gdk_cairo_set_source_pixbuf (cr, _tmp0_, 0.0, 0.0);
#line 99 "../src/game-board-view.vala"
	cairo_rectangle (cr, 0.0, 0.0, (gdouble) self->priv->board_size, (gdouble) self->priv->board_size);
#line 100 "../src/game-board-view.vala"
	cairo_paint (cr);
#line 101 "../src/game-board-view.vala"
	cairo_restore (cr);
#line 368 "game-board-view.c"
	{
		guint8 row = 0U;
#line 104 "../src/game-board-view.vala"
		row = (guint8) 0;
#line 373 "game-board-view.c"
		{
			gboolean _tmp1_ = FALSE;
#line 104 "../src/game-board-view.vala"
			_tmp1_ = TRUE;
#line 104 "../src/game-board-view.vala"
			while (TRUE) {
#line 380 "game-board-view.c"
				Board* _tmp3_;
				guint8 _tmp4_;
				guint8 _tmp5_;
#line 104 "../src/game-board-view.vala"
				if (!_tmp1_) {
#line 386 "game-board-view.c"
					guint8 _tmp2_;
#line 104 "../src/game-board-view.vala"
					_tmp2_ = row;
#line 104 "../src/game-board-view.vala"
					row = _tmp2_ + 1;
#line 392 "game-board-view.c"
				}
#line 104 "../src/game-board-view.vala"
				_tmp1_ = FALSE;
#line 104 "../src/game-board-view.vala"
				_tmp3_ = self->priv->_game_board;
#line 104 "../src/game-board-view.vala"
				_tmp4_ = board_get_size (_tmp3_);
#line 104 "../src/game-board-view.vala"
				_tmp5_ = _tmp4_;
#line 104 "../src/game-board-view.vala"
				if (!(row < _tmp5_)) {
#line 104 "../src/game-board-view.vala"
					break;
#line 406 "game-board-view.c"
				}
				{
					guint8 col = 0U;
#line 105 "../src/game-board-view.vala"
					col = (guint8) 0;
#line 412 "game-board-view.c"
					{
						gboolean _tmp6_ = FALSE;
#line 105 "../src/game-board-view.vala"
						_tmp6_ = TRUE;
#line 105 "../src/game-board-view.vala"
						while (TRUE) {
#line 419 "game-board-view.c"
							Board* _tmp8_;
							guint8 _tmp9_;
							guint8 _tmp10_;
#line 105 "../src/game-board-view.vala"
							if (!_tmp6_) {
#line 425 "game-board-view.c"
								guint8 _tmp7_;
#line 105 "../src/game-board-view.vala"
								_tmp7_ = col;
#line 105 "../src/game-board-view.vala"
								col = _tmp7_ + 1;
#line 431 "game-board-view.c"
							}
#line 105 "../src/game-board-view.vala"
							_tmp6_ = FALSE;
#line 105 "../src/game-board-view.vala"
							_tmp8_ = self->priv->_game_board;
#line 105 "../src/game-board-view.vala"
							_tmp9_ = board_get_size (_tmp8_);
#line 105 "../src/game-board-view.vala"
							_tmp10_ = _tmp9_;
#line 105 "../src/game-board-view.vala"
							if (!(col < _tmp10_)) {
#line 105 "../src/game-board-view.vala"
								break;
#line 445 "game-board-view.c"
							}
#line 106 "../src/game-board-view.vala"
							game_board_view_paint_tile (self, cr, row, col);
#line 449 "game-board-view.c"
						}
					}
				}
			}
		}
	}
#line 109 "../src/game-board-view.vala"
	cairo_save (cr);
#line 110 "../src/game-board-view.vala"
	cairo_translate (cr, (gdouble) self->priv->board_x, (gdouble) self->priv->board_y);
#line 111 "../src/game-board-view.vala"
	game_board_view_draw_grid (self, cr);
#line 112 "../src/game-board-view.vala"
	cairo_restore (cr);
#line 114 "../src/game-board-view.vala"
	result = FALSE;
#line 114 "../src/game-board-view.vala"
	return result;
#line 468 "game-board-view.c"
}

static inline void
game_board_view_paint_tile (GameBoardView* self,
                            cairo_t* cr,
                            guint8 row,
                            guint8 col)
{
	Player tile = 0;
	Board* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gint os = 0;
	gint x = 0;
	gint y = 0;
	GdkPixbuf* _tmp7_;
#line 117 "../src/game-board-view.vala"
	g_return_if_fail (self != NULL);
#line 117 "../src/game-board-view.vala"
	g_return_if_fail (cr != NULL);
#line 119 "../src/game-board-view.vala"
	_tmp0_ = self->priv->_game_board;
#line 119 "../src/game-board-view.vala"
	tile = board_get (_tmp0_, row, col);
#line 120 "../src/game-board-view.vala"
	if (tile == PLAYER_NOBODY) {
#line 120 "../src/game-board-view.vala"
		_tmp1_ = ((gint) row) != 0;
#line 496 "game-board-view.c"
	} else {
#line 120 "../src/game-board-view.vala"
		_tmp1_ = FALSE;
#line 500 "game-board-view.c"
	}
#line 120 "../src/game-board-view.vala"
	if (_tmp1_) {
#line 121 "../src/game-board-view.vala"
		return;
#line 506 "game-board-view.c"
	}
#line 123 "../src/game-board-view.vala"
	os = 0;
#line 124 "../src/game-board-view.vala"
	if (((gint) row) == 0) {
#line 125 "../src/game-board-view.vala"
		switch (tile) {
#line 125 "../src/game-board-view.vala"
			case PLAYER_HUMAN:
#line 516 "game-board-view.c"
			{
				gint _tmp2_;
#line 127 "../src/game-board-view.vala"
				_tmp2_ = self->priv->offset[GAME_BOARD_VIEW_TILE_PLAYER1_CURSOR];
#line 127 "../src/game-board-view.vala"
				os = _tmp2_;
#line 127 "../src/game-board-view.vala"
				break;
#line 525 "game-board-view.c"
			}
#line 125 "../src/game-board-view.vala"
			case PLAYER_OPPONENT:
#line 529 "game-board-view.c"
			{
				gint _tmp3_;
#line 128 "../src/game-board-view.vala"
				_tmp3_ = self->priv->offset[GAME_BOARD_VIEW_TILE_PLAYER2_CURSOR];
#line 128 "../src/game-board-view.vala"
				os = _tmp3_;
#line 128 "../src/game-board-view.vala"
				break;
#line 538 "game-board-view.c"
			}
#line 125 "../src/game-board-view.vala"
			case PLAYER_NOBODY:
#line 542 "game-board-view.c"
			{
				gint _tmp4_;
#line 129 "../src/game-board-view.vala"
				_tmp4_ = self->priv->offset[GAME_BOARD_VIEW_TILE_CLEAR_CURSOR];
#line 129 "../src/game-board-view.vala"
				os = _tmp4_;
#line 129 "../src/game-board-view.vala"
				break;
#line 551 "game-board-view.c"
			}
			default:
#line 125 "../src/game-board-view.vala"
			break;
#line 556 "game-board-view.c"
		}
	} else {
#line 132 "../src/game-board-view.vala"
		switch (tile) {
#line 132 "../src/game-board-view.vala"
			case PLAYER_HUMAN:
#line 563 "game-board-view.c"
			{
				gint _tmp5_;
#line 134 "../src/game-board-view.vala"
				_tmp5_ = self->priv->offset[GAME_BOARD_VIEW_TILE_PLAYER1];
#line 134 "../src/game-board-view.vala"
				os = _tmp5_;
#line 134 "../src/game-board-view.vala"
				break;
#line 572 "game-board-view.c"
			}
#line 132 "../src/game-board-view.vala"
			case PLAYER_OPPONENT:
#line 576 "game-board-view.c"
			{
				gint _tmp6_;
#line 135 "../src/game-board-view.vala"
				_tmp6_ = self->priv->offset[GAME_BOARD_VIEW_TILE_PLAYER2];
#line 135 "../src/game-board-view.vala"
				os = _tmp6_;
#line 135 "../src/game-board-view.vala"
				break;
#line 585 "game-board-view.c"
			}
#line 132 "../src/game-board-view.vala"
			case PLAYER_NOBODY:
#line 589 "game-board-view.c"
			{
#line 136 "../src/game-board-view.vala"
				g_assert_not_reached ();
#line 593 "game-board-view.c"
			}
			default:
#line 132 "../src/game-board-view.vala"
			break;
#line 598 "game-board-view.c"
		}
	}
#line 139 "../src/game-board-view.vala"
	cairo_save (cr);
#line 140 "../src/game-board-view.vala"
	x = (col * self->priv->tile_size) + self->priv->board_x;
#line 141 "../src/game-board-view.vala"
	y = (row * self->priv->tile_size) + self->priv->board_y;
#line 142 "../src/game-board-view.vala"
	_tmp7_ = self->priv->pb_tileset;
#line 142 "../src/game-board-view.vala"
	gdk_cairo_set_source_pixbuf (cr, _tmp7_, (gdouble) (x - os), (gdouble) y);
#line 143 "../src/game-board-view.vala"
	cairo_rectangle (cr, (gdouble) x, (gdouble) y, (gdouble) self->priv->tile_size, (gdouble) self->priv->tile_size);
#line 145 "../src/game-board-view.vala"
	cairo_clip (cr);
#line 146 "../src/game-board-view.vala"
	cairo_paint (cr);
#line 147 "../src/game-board-view.vala"
	cairo_restore (cr);
#line 619 "game-board-view.c"
}

static inline void
game_board_view_draw_grid (GameBoardView* self,
                           cairo_t* cr)
{
#line 152 "../src/game-board-view.vala"
	static const gdouble dashes[2] = {4.0, 4.0};
#line 628 "game-board-view.c"
	GdkRGBA color = {0};
	ThemeManager* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GdkRGBA _tmp3_;
#line 150 "../src/game-board-view.vala"
	g_return_if_fail (self != NULL);
#line 150 "../src/game-board-view.vala"
	g_return_if_fail (cr != NULL);
#line 153 "../src/game-board-view.vala"
	memset (&color, 0, sizeof (GdkRGBA));
#line 155 "../src/game-board-view.vala"
	_tmp0_ = self->priv->_theme_manager;
#line 155 "../src/game-board-view.vala"
	_tmp1_ = theme_manager_get_grid_color (_tmp0_);
#line 155 "../src/game-board-view.vala"
	_tmp2_ = _tmp1_;
#line 155 "../src/game-board-view.vala"
	gdk_rgba_parse (&color, _tmp2_);
#line 155 "../src/game-board-view.vala"
	_g_free0 (_tmp2_);
#line 156 "../src/game-board-view.vala"
	_tmp3_ = color;
#line 156 "../src/game-board-view.vala"
	gdk_cairo_set_source_rgba (cr, &_tmp3_);
#line 157 "../src/game-board-view.vala"
	cairo_set_operator (cr, CAIRO_OPERATOR_SOURCE);
#line 158 "../src/game-board-view.vala"
	cairo_set_line_width (cr, 1.0);
#line 159 "../src/game-board-view.vala"
	cairo_set_line_cap (cr, CAIRO_LINE_CAP_BUTT);
#line 160 "../src/game-board-view.vala"
	cairo_set_line_join (cr, CAIRO_LINE_JOIN_MITER);
#line 161 "../src/game-board-view.vala"
	cairo_set_dash (cr, dashes, (gint) G_N_ELEMENTS (dashes), 0.0);
#line 664 "game-board-view.c"
	{
		guint8 i = 0U;
#line 164 "../src/game-board-view.vala"
		i = (guint8) 1;
#line 669 "game-board-view.c"
		{
			gboolean _tmp4_ = FALSE;
#line 164 "../src/game-board-view.vala"
			_tmp4_ = TRUE;
#line 164 "../src/game-board-view.vala"
			while (TRUE) {
#line 676 "game-board-view.c"
				Board* _tmp6_;
				guint8 _tmp7_;
				guint8 _tmp8_;
				gdouble line_offset = 0.0;
#line 164 "../src/game-board-view.vala"
				if (!_tmp4_) {
#line 683 "game-board-view.c"
					guint8 _tmp5_;
#line 164 "../src/game-board-view.vala"
					_tmp5_ = i;
#line 164 "../src/game-board-view.vala"
					i = _tmp5_ + 1;
#line 689 "game-board-view.c"
				}
#line 164 "../src/game-board-view.vala"
				_tmp4_ = FALSE;
#line 164 "../src/game-board-view.vala"
				_tmp6_ = self->priv->_game_board;
#line 164 "../src/game-board-view.vala"
				_tmp7_ = board_get_size (_tmp6_);
#line 164 "../src/game-board-view.vala"
				_tmp8_ = _tmp7_;
#line 164 "../src/game-board-view.vala"
				if (!(i < _tmp8_)) {
#line 164 "../src/game-board-view.vala"
					break;
#line 703 "game-board-view.c"
				}
#line 166 "../src/game-board-view.vala"
				line_offset = (i * self->priv->tile_size) + 0.5;
#line 168 "../src/game-board-view.vala"
				cairo_move_to (cr, line_offset, 0.0);
#line 169 "../src/game-board-view.vala"
				cairo_line_to (cr, line_offset, (gdouble) self->priv->board_size);
#line 171 "../src/game-board-view.vala"
				cairo_move_to (cr, 0.0, line_offset);
#line 172 "../src/game-board-view.vala"
				cairo_line_to (cr, (gdouble) self->priv->board_size, line_offset);
#line 715 "game-board-view.c"
			}
		}
	}
#line 174 "../src/game-board-view.vala"
	cairo_stroke (cr);
#line 177 "../src/game-board-view.vala"
	cairo_set_dash (cr, NULL, (gint) 0, 0.0);
#line 178 "../src/game-board-view.vala"
	cairo_move_to (cr, 0.0, self->priv->tile_size + 0.5);
#line 179 "../src/game-board-view.vala"
	cairo_line_to (cr, (gdouble) self->priv->board_size, self->priv->tile_size + 0.5);
#line 181 "../src/game-board-view.vala"
	cairo_stroke (cr);
#line 729 "game-board-view.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 202 "../src/game-board-view.vala"
	return self ? g_object_ref (self) : NULL;
#line 737 "game-board-view.c"
}

static void
game_board_view_refresh_pixmaps (GameBoardView* self)
{
	GdkPixbuf* tmp_pixbuf = NULL;
	ThemeManager* _tmp0_;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GdkPixbuf* _tmp4_;
	GdkPixbuf* _tmp5_;
	GdkPixbuf* _tmp6_;
	ThemeManager* _tmp7_;
	GdkPixbuf* _tmp8_;
	GdkPixbuf* _tmp9_;
	GdkPixbuf* _tmp10_;
	GdkPixbuf* _tmp11_;
	GdkPixbuf* _tmp12_;
	GdkPixbuf* _tmp13_;
#line 192 "../src/game-board-view.vala"
	g_return_if_fail (self != NULL);
#line 194 "../src/game-board-view.vala"
	if (self->priv->tile_size == 0) {
#line 195 "../src/game-board-view.vala"
		return;
#line 764 "game-board-view.c"
	}
#line 199 "../src/game-board-view.vala"
	_tmp0_ = self->priv->_theme_manager;
#line 199 "../src/game-board-view.vala"
	_tmp1_ = theme_manager_get_pb_tileset_raw (_tmp0_);
#line 199 "../src/game-board-view.vala"
	_tmp2_ = _tmp1_;
#line 199 "../src/game-board-view.vala"
	_tmp3_ = gdk_pixbuf_scale_simple (_tmp2_, self->priv->tile_size * 6, self->priv->tile_size, GDK_INTERP_BILINEAR);
#line 199 "../src/game-board-view.vala"
	_g_object_unref0 (tmp_pixbuf);
#line 199 "../src/game-board-view.vala"
	tmp_pixbuf = _tmp3_;
#line 200 "../src/game-board-view.vala"
	_tmp4_ = tmp_pixbuf;
#line 200 "../src/game-board-view.vala"
	if (_tmp4_ == NULL) {
#line 201 "../src/game-board-view.vala"
		g_assert_not_reached ();
#line 784 "game-board-view.c"
	}
#line 202 "../src/game-board-view.vala"
	_tmp5_ = tmp_pixbuf;
#line 202 "../src/game-board-view.vala"
	_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gdk_pixbuf_get_type (), GdkPixbuf));
#line 202 "../src/game-board-view.vala"
	_g_object_unref0 (self->priv->pb_tileset);
#line 202 "../src/game-board-view.vala"
	self->priv->pb_tileset = _tmp6_;
#line 204 "../src/game-board-view.vala"
	_tmp7_ = self->priv->_theme_manager;
#line 204 "../src/game-board-view.vala"
	_tmp8_ = theme_manager_get_pb_bground_raw (_tmp7_);
#line 204 "../src/game-board-view.vala"
	_tmp9_ = _tmp8_;
#line 204 "../src/game-board-view.vala"
	_tmp10_ = gdk_pixbuf_scale_simple (_tmp9_, self->priv->board_size, self->priv->board_size, GDK_INTERP_BILINEAR);
#line 204 "../src/game-board-view.vala"
	_g_object_unref0 (tmp_pixbuf);
#line 204 "../src/game-board-view.vala"
	tmp_pixbuf = _tmp10_;
#line 205 "../src/game-board-view.vala"
	_tmp11_ = tmp_pixbuf;
#line 205 "../src/game-board-view.vala"
	if (_tmp11_ == NULL) {
#line 206 "../src/game-board-view.vala"
		g_assert_not_reached ();
#line 812 "game-board-view.c"
	}
#line 207 "../src/game-board-view.vala"
	_tmp12_ = tmp_pixbuf;
#line 207 "../src/game-board-view.vala"
	_tmp13_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gdk_pixbuf_get_type (), GdkPixbuf));
#line 207 "../src/game-board-view.vala"
	_g_object_unref0 (self->priv->pb_bground);
#line 207 "../src/game-board-view.vala"
	self->priv->pb_bground = _tmp13_;
#line 209 "../src/game-board-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 192 "../src/game-board-view.vala"
	_g_object_unref0 (tmp_pixbuf);
#line 826 "game-board-view.c"
}

static void
_game_board_view_on_click_gtk_gesture_multi_press_pressed (GtkGestureMultiPress* _sender,
                                                           gint n_press,
                                                           gdouble x,
                                                           gdouble y,
                                                           gpointer self)
{
#line 222 "../src/game-board-view.vala"
	game_board_view_on_click ((GameBoardView*) self, _sender, n_press, x, y);
#line 838 "game-board-view.c"
}

static inline void
game_board_view_init_mouse (GameBoardView* self)
{
	GtkGestureMultiPress* _tmp0_;
	GtkGestureMultiPress* _tmp1_;
	GtkGestureMultiPress* _tmp2_;
#line 218 "../src/game-board-view.vala"
	g_return_if_fail (self != NULL);
#line 220 "../src/game-board-view.vala"
	_tmp0_ = (GtkGestureMultiPress*) gtk_gesture_multi_press_new ((GtkWidget*) self);
#line 220 "../src/game-board-view.vala"
	_g_object_unref0 (self->priv->click_controller);
#line 220 "../src/game-board-view.vala"
	self->priv->click_controller = _tmp0_;
#line 221 "../src/game-board-view.vala"
	_tmp1_ = self->priv->click_controller;
#line 221 "../src/game-board-view.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp1_, (guint) 0);
#line 222 "../src/game-board-view.vala"
	_tmp2_ = self->priv->click_controller;
#line 222 "../src/game-board-view.vala"
	g_signal_connect_object (_tmp2_, "pressed", (GCallback) _game_board_view_on_click_gtk_gesture_multi_press_pressed, self, 0);
#line 863 "game-board-view.c"
}

static void
_vala_GdkEvent_free (GdkEvent* self)
{
#line 236 "../src/game-board-view.vala"
	g_boxed_free (gdk_event_get_type (), self);
#line 871 "game-board-view.c"
}

static inline void
game_board_view_on_click (GameBoardView* self,
                          GtkGestureMultiPress* _click_controller,
                          gint n_press,
                          gdouble event_x,
                          gdouble event_y)
{
	guint button = 0U;
	gboolean _tmp0_ = FALSE;
	GdkEvent* event = NULL;
	GdkEvent* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GdkEvent* _tmp3_;
	gint x = 0;
	gint y = 0;
	GdkWindow* window = NULL;
	GdkWindow* _tmp5_;
	GdkWindow* _tmp6_;
	GdkWindow* _tmp7_;
	GdkWindow* _tmp8_;
	GdkEvent* _tmp9_;
	GdkDevice* _tmp10_;
	gint _tmp11_ = 0;
	gint _tmp12_ = 0;
	guint8 col = 0U;
	guint8 _tmp13_ = 0U;
	gboolean _tmp14_;
#line 236 "../src/game-board-view.vala"
	g_return_if_fail (self != NULL);
#line 236 "../src/game-board-view.vala"
	g_return_if_fail (_click_controller != NULL);
#line 238 "../src/game-board-view.vala"
	button = gtk_gesture_single_get_current_button ((GtkGestureSingle*) _click_controller);
#line 239 "../src/game-board-view.vala"
	if (button != ((guint) GDK_BUTTON_PRIMARY)) {
#line 239 "../src/game-board-view.vala"
		_tmp0_ = button != ((guint) GDK_BUTTON_SECONDARY);
#line 911 "game-board-view.c"
	} else {
#line 239 "../src/game-board-view.vala"
		_tmp0_ = FALSE;
#line 915 "game-board-view.c"
	}
#line 239 "../src/game-board-view.vala"
	if (_tmp0_) {
#line 240 "../src/game-board-view.vala"
		return;
#line 921 "game-board-view.c"
	}
#line 242 "../src/game-board-view.vala"
	_tmp1_ = gtk_get_current_event ();
#line 242 "../src/game-board-view.vala"
	event = _tmp1_;
#line 243 "../src/game-board-view.vala"
	_tmp3_ = event;
#line 243 "../src/game-board-view.vala"
	if (_tmp3_ == NULL) {
#line 931 "game-board-view.c"
		GdkEvent* _tmp4_;
#line 243 "../src/game-board-view.vala"
		_tmp4_ = event;
#line 243 "../src/game-board-view.vala"
		_tmp2_ = ((GdkEvent*) _tmp4_)->type != GDK_BUTTON_PRESS;
#line 937 "game-board-view.c"
	} else {
#line 243 "../src/game-board-view.vala"
		_tmp2_ = FALSE;
#line 941 "game-board-view.c"
	}
#line 243 "../src/game-board-view.vala"
	if (_tmp2_) {
#line 244 "../src/game-board-view.vala"
		g_assert_not_reached ();
#line 947 "game-board-view.c"
	}
#line 248 "../src/game-board-view.vala"
	_tmp5_ = gtk_widget_get_window ((GtkWidget*) self);
#line 248 "../src/game-board-view.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 248 "../src/game-board-view.vala"
	window = _tmp6_;
#line 249 "../src/game-board-view.vala"
	_tmp7_ = window;
#line 249 "../src/game-board-view.vala"
	if (_tmp7_ == NULL) {
#line 250 "../src/game-board-view.vala"
		g_assert_not_reached ();
#line 961 "game-board-view.c"
	}
#line 251 "../src/game-board-view.vala"
	_tmp8_ = window;
#line 251 "../src/game-board-view.vala"
	_tmp9_ = event;
#line 251 "../src/game-board-view.vala"
	_tmp10_ = ((GdkEventButton*) ((GdkEvent*) _tmp9_))->device;
#line 251 "../src/game-board-view.vala"
	gdk_window_get_device_position (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gdk_window_get_type (), GdkWindow), _tmp10_, &_tmp11_, &_tmp12_, NULL);
#line 251 "../src/game-board-view.vala"
	x = _tmp11_;
#line 251 "../src/game-board-view.vala"
	y = _tmp12_;
#line 254 "../src/game-board-view.vala"
	_tmp14_ = game_board_view_get_column (self, x, y, &_tmp13_);
#line 254 "../src/game-board-view.vala"
	col = _tmp13_;
#line 254 "../src/game-board-view.vala"
	if (_tmp14_) {
#line 981 "game-board-view.c"
		gboolean _tmp15_ = FALSE;
#line 255 "../src/game-board-view.vala"
		g_signal_emit (self, game_board_view_signals[GAME_BOARD_VIEW_COLUMN_CLICKED_SIGNAL], 0, col, &_tmp15_);
#line 985 "game-board-view.c"
	}
#line 236 "../src/game-board-view.vala"
	_g_object_unref0 (window);
#line 236 "../src/game-board-view.vala"
	__vala_GdkEvent_free0 (event);
#line 991 "game-board-view.c"
}

static inline gboolean
game_board_view_get_column (GameBoardView* self,
                            gint x,
                            gint y,
                            guint8* col)
{
	guint8 _vala_col = 0U;
	gint _col = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gint row = 0;
	gboolean _tmp6_ = FALSE;
	gboolean result;
#line 258 "../src/game-board-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 260 "../src/game-board-view.vala"
	_col = (x - self->priv->board_x) / self->priv->tile_size;
#line 261 "../src/game-board-view.vala"
	if (x < self->priv->board_x) {
#line 261 "../src/game-board-view.vala"
		_tmp2_ = TRUE;
#line 1016 "game-board-view.c"
	} else {
#line 261 "../src/game-board-view.vala"
		_tmp2_ = y < self->priv->board_y;
#line 1020 "game-board-view.c"
	}
#line 261 "../src/game-board-view.vala"
	if (_tmp2_) {
#line 261 "../src/game-board-view.vala"
		_tmp1_ = TRUE;
#line 1026 "game-board-view.c"
	} else {
#line 261 "../src/game-board-view.vala"
		_tmp1_ = _col < 0;
#line 1030 "game-board-view.c"
	}
#line 261 "../src/game-board-view.vala"
	if (_tmp1_) {
#line 261 "../src/game-board-view.vala"
		_tmp0_ = TRUE;
#line 1036 "game-board-view.c"
	} else {
		Board* _tmp3_;
		guint8 _tmp4_;
		guint8 _tmp5_;
#line 261 "../src/game-board-view.vala"
		_tmp3_ = self->priv->_game_board;
#line 261 "../src/game-board-view.vala"
		_tmp4_ = board_get_size (_tmp3_);
#line 261 "../src/game-board-view.vala"
		_tmp5_ = _tmp4_;
#line 261 "../src/game-board-view.vala"
		_tmp0_ = _col > (_tmp5_ - 1);
#line 1049 "game-board-view.c"
	}
#line 261 "../src/game-board-view.vala"
	if (_tmp0_) {
#line 263 "../src/game-board-view.vala"
		_vala_col = (guint8) 0;
#line 264 "../src/game-board-view.vala"
		result = FALSE;
#line 264 "../src/game-board-view.vala"
		if (col) {
#line 264 "../src/game-board-view.vala"
			*col = _vala_col;
#line 1061 "game-board-view.c"
		}
#line 264 "../src/game-board-view.vala"
		return result;
#line 1065 "game-board-view.c"
	}
#line 266 "../src/game-board-view.vala"
	_vala_col = (guint8) _col;
#line 268 "../src/game-board-view.vala"
	row = (y - self->priv->board_y) / self->priv->tile_size;
#line 269 "../src/game-board-view.vala"
	if (row < 0) {
#line 269 "../src/game-board-view.vala"
		_tmp6_ = TRUE;
#line 1075 "game-board-view.c"
	} else {
		Board* _tmp7_;
		guint8 _tmp8_;
		guint8 _tmp9_;
#line 269 "../src/game-board-view.vala"
		_tmp7_ = self->priv->_game_board;
#line 269 "../src/game-board-view.vala"
		_tmp8_ = board_get_size (_tmp7_);
#line 269 "../src/game-board-view.vala"
		_tmp9_ = _tmp8_;
#line 269 "../src/game-board-view.vala"
		_tmp6_ = row > (_tmp9_ - 1);
#line 1088 "game-board-view.c"
	}
#line 269 "../src/game-board-view.vala"
	if (_tmp6_) {
#line 270 "../src/game-board-view.vala"
		result = FALSE;
#line 270 "../src/game-board-view.vala"
		if (col) {
#line 270 "../src/game-board-view.vala"
			*col = _vala_col;
#line 1098 "game-board-view.c"
		}
#line 270 "../src/game-board-view.vala"
		return result;
#line 1102 "game-board-view.c"
	}
#line 272 "../src/game-board-view.vala"
	result = TRUE;
#line 272 "../src/game-board-view.vala"
	if (col) {
#line 272 "../src/game-board-view.vala"
		*col = _vala_col;
#line 1110 "game-board-view.c"
	}
#line 272 "../src/game-board-view.vala"
	return result;
#line 1114 "game-board-view.c"
}

static Board*
game_board_view_get_game_board (GameBoardView* self)
{
	Board* result;
	Board* _tmp0_;
#line 32 "../src/game-board-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../src/game-board-view.vala"
	_tmp0_ = self->priv->_game_board;
#line 32 "../src/game-board-view.vala"
	result = _tmp0_;
#line 32 "../src/game-board-view.vala"
	return result;
#line 1130 "game-board-view.c"
}

static void
game_board_view_set_game_board (GameBoardView* self,
                                Board* value)
{
	Board* _tmp0_;
#line 32 "../src/game-board-view.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/game-board-view.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 32 "../src/game-board-view.vala"
	_g_object_unref0 (self->priv->_game_board);
#line 32 "../src/game-board-view.vala"
	self->priv->_game_board = _tmp0_;
#line 1146 "game-board-view.c"
}

static ThemeManager*
game_board_view_get_theme_manager (GameBoardView* self)
{
	ThemeManager* result;
	ThemeManager* _tmp0_;
#line 33 "../src/game-board-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../src/game-board-view.vala"
	_tmp0_ = self->priv->_theme_manager;
#line 33 "../src/game-board-view.vala"
	result = _tmp0_;
#line 33 "../src/game-board-view.vala"
	return result;
#line 1162 "game-board-view.c"
}

static void
game_board_view_set_theme_manager (GameBoardView* self,
                                   ThemeManager* value)
{
	ThemeManager* _tmp0_;
#line 33 "../src/game-board-view.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/game-board-view.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 33 "../src/game-board-view.vala"
	_g_object_unref0 (self->priv->_theme_manager);
#line 33 "../src/game-board-view.vala"
	self->priv->_theme_manager = _tmp0_;
#line 1178 "game-board-view.c"
}

static void
g_cclosure_user_marshal_BOOLEAN__UCHAR (GClosure * closure,
                                        GValue * return_value,
                                        guint n_param_values,
                                        const GValue * param_values,
                                        gpointer invocation_hint,
                                        gpointer marshal_data)
{
	typedef gboolean (*GMarshalFunc_BOOLEAN__UCHAR) (gpointer data1, guint8 arg_1, gpointer data2);
	register GMarshalFunc_BOOLEAN__UCHAR callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	gboolean v_return;
	cc = (GCClosure *) closure;
#line 21 "../src/game-board-view.vala"
	g_return_if_fail (return_value != NULL);
#line 21 "../src/game-board-view.vala"
	g_return_if_fail (n_param_values == 2);
#line 21 "../src/game-board-view.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 21 "../src/game-board-view.vala"
		data1 = closure->data;
#line 21 "../src/game-board-view.vala"
		data2 = param_values->data[0].v_pointer;
#line 1206 "game-board-view.c"
	} else {
#line 21 "../src/game-board-view.vala"
		data1 = param_values->data[0].v_pointer;
#line 21 "../src/game-board-view.vala"
		data2 = closure->data;
#line 1212 "game-board-view.c"
	}
#line 21 "../src/game-board-view.vala"
	callback = (GMarshalFunc_BOOLEAN__UCHAR) (marshal_data ? marshal_data : cc->callback);
#line 21 "../src/game-board-view.vala"
	v_return = callback (data1, g_value_get_uchar (param_values + 1), data2);
#line 21 "../src/game-board-view.vala"
	g_value_set_boolean (return_value, v_return);
#line 1220 "game-board-view.c"
}

static void
_game_board_view_refresh_pixmaps_theme_manager_theme_changed (ThemeManager* _sender,
                                                              gpointer self)
{
#line 45 "../src/game-board-view.vala"
	game_board_view_refresh_pixmaps ((GameBoardView*) self);
#line 1229 "game-board-view.c"
}

static GObject *
game_board_view_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GameBoardView * self;
	ThemeManager* _tmp0_;
#line 40 "../src/game-board-view.vala"
	parent_class = G_OBJECT_CLASS (game_board_view_parent_class);
#line 40 "../src/game-board-view.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 40 "../src/game-board-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME_BOARD_VIEW, GameBoardView);
#line 42 "../src/game-board-view.vala"
	gtk_widget_set_events ((GtkWidget*) self, (GDK_EXPOSURE_MASK | GDK_BUTTON_PRESS_MASK) | GDK_BUTTON_RELEASE_MASK);
#line 45 "../src/game-board-view.vala"
	_tmp0_ = self->priv->_theme_manager;
#line 45 "../src/game-board-view.vala"
	g_signal_connect_object (_tmp0_, "theme-changed", (GCallback) _game_board_view_refresh_pixmaps_theme_manager_theme_changed, self, 0);
#line 47 "../src/game-board-view.vala"
	game_board_view_init_mouse (self);
#line 40 "../src/game-board-view.vala"
	return obj;
#line 1257 "game-board-view.c"
}

static void
game_board_view_class_init (GameBoardViewClass * klass,
                            gpointer klass_data)
{
#line 21 "../src/game-board-view.vala"
	game_board_view_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/game-board-view.vala"
	g_type_class_adjust_private_offset (klass, &GameBoardView_private_offset);
#line 21 "../src/game-board-view.vala"
	((GtkWidgetClass *) klass)->configure_event = (gboolean (*) (GtkWidget*, GdkEventConfigure*)) game_board_view_real_configure_event;
#line 21 "../src/game-board-view.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) game_board_view_real_draw;
#line 21 "../src/game-board-view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_game_board_view_get_property;
#line 21 "../src/game-board-view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_game_board_view_set_property;
#line 21 "../src/game-board-view.vala"
	G_OBJECT_CLASS (klass)->constructor = game_board_view_constructor;
#line 21 "../src/game-board-view.vala"
	G_OBJECT_CLASS (klass)->finalize = game_board_view_finalize;
#line 21 "../src/game-board-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_BOARD_VIEW_GAME_BOARD_PROPERTY, game_board_view_properties[GAME_BOARD_VIEW_GAME_BOARD_PROPERTY] = g_param_spec_object ("game-board", "game-board", "game-board", TYPE_BOARD, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 21 "../src/game-board-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_BOARD_VIEW_THEME_MANAGER_PROPERTY, game_board_view_properties[GAME_BOARD_VIEW_THEME_MANAGER_PROPERTY] = g_param_spec_object ("theme-manager", "theme-manager", "theme-manager", TYPE_THEME_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 1284 "game-board-view.c"
	/**
	     * column_clicked:
	     *
	     * emitted when a column on the game board is clicked
	     *
	     * @column:
	     *
	     * Which column was clicked on
	     */
#line 21 "../src/game-board-view.vala"
	game_board_view_signals[GAME_BOARD_VIEW_COLUMN_CLICKED_SIGNAL] = g_signal_new ("column-clicked", TYPE_GAME_BOARD_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_BOOLEAN__UCHAR, G_TYPE_BOOLEAN, 1, G_TYPE_UCHAR);
#line 1296 "game-board-view.c"
}

static void
game_board_view_instance_init (GameBoardView * self,
                               gpointer klass)
{
#line 21 "../src/game-board-view.vala"
	self->priv = game_board_view_get_instance_private (self);
#line 54 "../src/game-board-view.vala"
	self->priv->board_size = 0;
#line 55 "../src/game-board-view.vala"
	self->priv->tile_size = 0;
#line 1309 "game-board-view.c"
}

static void
game_board_view_finalize (GObject * obj)
{
	GameBoardView * self;
#line 21 "../src/game-board-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME_BOARD_VIEW, GameBoardView);
#line 32 "../src/game-board-view.vala"
	_g_object_unref0 (self->priv->_game_board);
#line 33 "../src/game-board-view.vala"
	_g_object_unref0 (self->priv->_theme_manager);
#line 189 "../src/game-board-view.vala"
	_g_object_unref0 (self->priv->pb_tileset);
#line 190 "../src/game-board-view.vala"
	_g_object_unref0 (self->priv->pb_bground);
#line 216 "../src/game-board-view.vala"
	_g_object_unref0 (self->priv->click_controller);
#line 21 "../src/game-board-view.vala"
	G_OBJECT_CLASS (game_board_view_parent_class)->finalize (obj);
#line 1330 "game-board-view.c"
}

static GType
game_board_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GameBoardViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_board_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameBoardView), 0, (GInstanceInitFunc) game_board_view_instance_init, NULL };
	GType game_board_view_type_id;
	game_board_view_type_id = g_type_register_static (gtk_drawing_area_get_type (), "GameBoardView", &g_define_type_info, 0);
	GameBoardView_private_offset = g_type_add_instance_private (game_board_view_type_id, sizeof (GameBoardViewPrivate));
	return game_board_view_type_id;
}

GType
game_board_view_get_type (void)
{
	static volatile gsize game_board_view_type_id__once = 0;
	if (g_once_init_enter (&game_board_view_type_id__once)) {
		GType game_board_view_type_id;
		game_board_view_type_id = game_board_view_get_type_once ();
		g_once_init_leave (&game_board_view_type_id__once, game_board_view_type_id);
	}
	return game_board_view_type_id__once;
}

static void
_vala_game_board_view_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	GameBoardView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME_BOARD_VIEW, GameBoardView);
#line 21 "../src/game-board-view.vala"
	switch (property_id) {
#line 21 "../src/game-board-view.vala"
		case GAME_BOARD_VIEW_GAME_BOARD_PROPERTY:
#line 21 "../src/game-board-view.vala"
		g_value_set_object (value, game_board_view_get_game_board (self));
#line 21 "../src/game-board-view.vala"
		break;
#line 21 "../src/game-board-view.vala"
		case GAME_BOARD_VIEW_THEME_MANAGER_PROPERTY:
#line 21 "../src/game-board-view.vala"
		g_value_set_object (value, game_board_view_get_theme_manager (self));
#line 21 "../src/game-board-view.vala"
		break;
#line 1377 "game-board-view.c"
		default:
#line 21 "../src/game-board-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/game-board-view.vala"
		break;
#line 1383 "game-board-view.c"
	}
}

static void
_vala_game_board_view_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	GameBoardView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME_BOARD_VIEW, GameBoardView);
#line 21 "../src/game-board-view.vala"
	switch (property_id) {
#line 21 "../src/game-board-view.vala"
		case GAME_BOARD_VIEW_GAME_BOARD_PROPERTY:
#line 21 "../src/game-board-view.vala"
		game_board_view_set_game_board (self, g_value_get_object (value));
#line 21 "../src/game-board-view.vala"
		break;
#line 21 "../src/game-board-view.vala"
		case GAME_BOARD_VIEW_THEME_MANAGER_PROPERTY:
#line 21 "../src/game-board-view.vala"
		game_board_view_set_theme_manager (self, g_value_get_object (value));
#line 21 "../src/game-board-view.vala"
		break;
#line 1409 "game-board-view.c"
		default:
#line 21 "../src/game-board-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/game-board-view.vala"
		break;
#line 1415 "game-board-view.c"
	}
}

