/* history-button.c generated by valac 0.56.3, the Vala compiler
 * generated from history-button.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
   This file is part of GNOME Four-in-a-row.

   Copyright © 2015, 2016, 2019 Arnaud Bonatti

   GNOME Four-in-a-row is free software: you can redistribute it and/or
   modify it under the terms of the GNU General Public License as published
   by the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   GNOME Four-in-a-row is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with GNOME Four-in-a-row.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gio/gio.h>
#include <cairo-gobject.h>
#include <gdk/gdk.h>

#define HISTORY_BUTTON_pixbuf_margin 1
#define HISTORY_BUTTON_arrow_margin_top 3.0
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_ADAPTATIVE_WIDGET (adaptative_widget_get_type ())
#define ADAPTATIVE_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ADAPTATIVE_WIDGET, AdaptativeWidget))
#define IS_ADAPTATIVE_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ADAPTATIVE_WIDGET))
#define ADAPTATIVE_WIDGET_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_ADAPTATIVE_WIDGET, AdaptativeWidgetIface))

typedef struct _AdaptativeWidget AdaptativeWidget;
typedef struct _AdaptativeWidgetIface AdaptativeWidgetIface;
typedef enum  {
	ADAPTATIVE_WIDGET_WINDOW_SIZE_START_SIZE,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_USUAL_SIZE,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_QUITE_THIN,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_VERT,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_HZTL,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_PHONE_BOTH,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_EXTRA_THIN,
	ADAPTATIVE_WIDGET_WINDOW_SIZE_EXTRA_FLAT
} AdaptativeWidgetWindowSize;

#define ADAPTATIVE_WIDGET_TYPE_WINDOW_SIZE (adaptative_widget_window_size_get_type ())

#define TYPE_HISTORY_BUTTON (history_button_get_type ())
#define HISTORY_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HISTORY_BUTTON, HistoryButton))
#define HISTORY_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HISTORY_BUTTON, HistoryButtonClass))
#define IS_HISTORY_BUTTON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HISTORY_BUTTON))
#define IS_HISTORY_BUTTON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HISTORY_BUTTON))
#define HISTORY_BUTTON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HISTORY_BUTTON, HistoryButtonClass))

typedef struct _HistoryButton HistoryButton;
typedef struct _HistoryButtonClass HistoryButtonClass;
typedef struct _HistoryButtonPrivate HistoryButtonPrivate;

#define TYPE_THEME_MANAGER (theme_manager_get_type ())
#define THEME_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THEME_MANAGER, ThemeManager))
#define THEME_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THEME_MANAGER, ThemeManagerClass))
#define IS_THEME_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THEME_MANAGER))
#define IS_THEME_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THEME_MANAGER))
#define THEME_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THEME_MANAGER, ThemeManagerClass))

typedef struct _ThemeManager ThemeManager;
typedef struct _ThemeManagerClass ThemeManagerClass;
typedef enum  {
	PLAYER_NOBODY,
	PLAYER_HUMAN,
	PLAYER_OPPONENT
} Player;

#define TYPE_PLAYER (player_get_type ())
enum  {
	HISTORY_BUTTON_0_PROPERTY,
	HISTORY_BUTTON_THEME_MANAGER_PROPERTY,
	HISTORY_BUTTON_NUM_PROPERTIES
};
static GParamSpec* history_button_properties[HISTORY_BUTTON_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _AdaptativeWidgetIface {
	GTypeInterface parent_iface;
	void (*set_window_size) (AdaptativeWidget* self, AdaptativeWidgetWindowSize new_size);
};

struct _HistoryButton {
	GtkMenuButton parent_instance;
	HistoryButtonPrivate * priv;
};

struct _HistoryButtonClass {
	GtkMenuButtonClass parent_class;
};

struct _HistoryButtonPrivate {
	ThemeManager* _theme_manager;
	GtkStack* stack;
	GtkDrawingArea* drawing;
	gboolean drawing_configured;
	gint drawing_height;
	gint drawing_width;
	gint pixbuf_size;
	gdouble arrow_half_width;
	gint board_x;
	gint board_y;
	GdkPixbuf* tileset_pixbuf;
	Player current_player;
};

static gint HistoryButton_private_offset;
static gpointer history_button_parent_class = NULL;
static AdaptativeWidgetIface * history_button_adaptative_widget_parent_iface = NULL;

VALA_EXTERN GType adaptative_widget_window_size_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType adaptative_widget_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AdaptativeWidget, g_object_unref)
VALA_EXTERN GType history_button_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HistoryButton, g_object_unref)
VALA_EXTERN GType theme_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ThemeManager, g_object_unref)
VALA_EXTERN GType player_get_type (void) G_GNUC_CONST ;
VALA_EXTERN HistoryButton* history_button_new (GMenu** menu,
                                   ThemeManager* theme_manager);
VALA_EXTERN HistoryButton* history_button_construct (GType object_type,
                                         GMenu** menu,
                                         ThemeManager* theme_manager);
static void history_button_real_set_window_size (AdaptativeWidget* base,
                                          AdaptativeWidgetWindowSize new_size);
VALA_EXTERN void history_button_set_player (HistoryButton* self,
                                Player player);
static gboolean history_button_configure_drawing (HistoryButton* self);
static void history_button_init_pixbuf (HistoryButton* self);
static ThemeManager* history_button_get_theme_manager (HistoryButton* self);
VALA_EXTERN GdkPixbuf* theme_manager_get_pb_tileset_raw (ThemeManager* self);
static gboolean history_button_update_drawing (HistoryButton* self,
                                        cairo_t* cr);
static void history_button_draw_arrow (HistoryButton* self,
                                cairo_t* cr);
static void history_button_draw_piece (HistoryButton* self,
                                cairo_t* cr);
static void history_button_set_theme_manager (HistoryButton* self,
                                       ThemeManager* value);
static GObject * history_button_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties);
static gboolean _history_button_configure_drawing_gtk_widget_configure_event (GtkWidget* _sender,
                                                                       GdkEventConfigure* event,
                                                                       gpointer self);
static gboolean _history_button_update_drawing_gtk_widget_draw (GtkWidget* _sender,
                                                         cairo_t* cr,
                                                         gpointer self);
static void _history_button___lambda6_ (HistoryButton* self);
static void __history_button___lambda6__theme_manager_theme_changed (ThemeManager* _sender,
                                                              gpointer self);
VALA_EXTERN void adaptative_widget_set_window_size (AdaptativeWidget* self,
                                        AdaptativeWidgetWindowSize new_size);
static void history_button_finalize (GObject * obj);
static GType history_button_get_type_once (void);
static void _vala_history_button_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_history_button_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);

static inline gpointer
history_button_get_instance_private (HistoryButton* self)
{
	return G_STRUCT_MEMBER_P (self, HistoryButton_private_offset);
}

HistoryButton*
history_button_construct (GType object_type,
                          GMenu** menu,
                          ThemeManager* theme_manager)
{
	HistoryButton * self = NULL;
#line 31 "../src/history-button.vala"
	g_return_val_if_fail (*menu != NULL, NULL);
#line 31 "../src/history-button.vala"
	g_return_val_if_fail (theme_manager != NULL, NULL);
#line 33 "../src/history-button.vala"
	self = (HistoryButton*) g_object_new (object_type, "menu-model", *menu, "theme-manager", theme_manager, NULL);
#line 31 "../src/history-button.vala"
	return self;
#line 209 "history-button.c"
}

HistoryButton*
history_button_new (GMenu** menu,
                    ThemeManager* theme_manager)
{
#line 31 "../src/history-button.vala"
	return history_button_construct (TYPE_HISTORY_BUTTON, menu, theme_manager);
#line 218 "history-button.c"
}

static void
history_button_real_set_window_size (AdaptativeWidget* base,
                                     AdaptativeWidgetWindowSize new_size)
{
	HistoryButton * self;
#line 49 "../src/history-button.vala"
	self = (HistoryButton*) base;
#line 228 "history-button.c"
}

void
history_button_set_player (HistoryButton* self,
                           Player player)
{
#line 53 "../src/history-button.vala"
	g_return_if_fail (self != NULL);
#line 55 "../src/history-button.vala"
	self->priv->current_player = player;
#line 56 "../src/history-button.vala"
	if (player == PLAYER_NOBODY) {
#line 241 "history-button.c"
		GtkStack* _tmp0_;
#line 57 "../src/history-button.vala"
		_tmp0_ = self->priv->stack;
#line 57 "../src/history-button.vala"
		gtk_stack_set_visible_child_name (_tmp0_, "label");
#line 247 "history-button.c"
	} else {
		GtkStack* _tmp1_;
		GtkDrawingArea* _tmp2_;
		GtkDrawingArea* _tmp3_;
#line 60 "../src/history-button.vala"
		_tmp1_ = self->priv->stack;
#line 60 "../src/history-button.vala"
		_tmp2_ = self->priv->drawing;
#line 60 "../src/history-button.vala"
		gtk_stack_set_visible_child (_tmp1_, (GtkWidget*) _tmp2_);
#line 61 "../src/history-button.vala"
		_tmp3_ = self->priv->drawing;
#line 61 "../src/history-button.vala"
		gtk_widget_queue_draw ((GtkWidget*) _tmp3_);
#line 262 "history-button.c"
	}
}

static gboolean
history_button_configure_drawing (HistoryButton* self)
{
	gint height = 0;
	GtkDrawingArea* _tmp0_;
	gint width = 0;
	GtkDrawingArea* _tmp1_;
	gint new_height = 0;
	gboolean refresh_pixbuf = FALSE;
	gboolean vertical_fill = FALSE;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gboolean result;
#line 80 "../src/history-button.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 82 "../src/history-button.vala"
	_tmp0_ = self->priv->drawing;
#line 82 "../src/history-button.vala"
	height = gtk_widget_get_allocated_height ((GtkWidget*) _tmp0_);
#line 83 "../src/history-button.vala"
	_tmp1_ = self->priv->drawing;
#line 83 "../src/history-button.vala"
	width = gtk_widget_get_allocated_width ((GtkWidget*) _tmp1_);
#line 84 "../src/history-button.vala"
	new_height = (gint) MIN ((gdouble) height, width / 2.0);
#line 86 "../src/history-button.vala"
	refresh_pixbuf = self->priv->drawing_height != new_height;
#line 87 "../src/history-button.vala"
	self->priv->drawing_height = new_height;
#line 88 "../src/history-button.vala"
	self->priv->pixbuf_size = self->priv->drawing_height - (2 * HISTORY_BUTTON_pixbuf_margin);
#line 89 "../src/history-button.vala"
	if (refresh_pixbuf) {
#line 90 "../src/history-button.vala"
		history_button_init_pixbuf (self);
#line 302 "history-button.c"
	}
#line 91 "../src/history-button.vala"
	self->priv->arrow_half_width = self->priv->pixbuf_size / 4.0;
#line 93 "../src/history-button.vala"
	vertical_fill = height == new_height;
#line 94 "../src/history-button.vala"
	if (vertical_fill) {
#line 94 "../src/history-button.vala"
		_tmp2_ = (gint) (new_height * 2.0);
#line 312 "history-button.c"
	} else {
#line 94 "../src/history-button.vala"
		_tmp2_ = width;
#line 316 "history-button.c"
	}
#line 94 "../src/history-button.vala"
	self->priv->drawing_width = _tmp2_;
#line 95 "../src/history-button.vala"
	if (vertical_fill) {
#line 95 "../src/history-button.vala"
		_tmp3_ = (gint) ((width - self->priv->drawing_width) / 2.0);
#line 324 "history-button.c"
	} else {
#line 95 "../src/history-button.vala"
		_tmp3_ = 0;
#line 328 "history-button.c"
	}
#line 95 "../src/history-button.vala"
	self->priv->board_x = _tmp3_;
#line 96 "../src/history-button.vala"
	if (!vertical_fill) {
#line 96 "../src/history-button.vala"
		_tmp4_ = (gint) ((height - self->priv->drawing_height) / 2.0);
#line 336 "history-button.c"
	} else {
#line 96 "../src/history-button.vala"
		_tmp4_ = 0;
#line 340 "history-button.c"
	}
#line 96 "../src/history-button.vala"
	self->priv->board_y = _tmp4_;
#line 98 "../src/history-button.vala"
	self->priv->drawing_configured = TRUE;
#line 99 "../src/history-button.vala"
	result = TRUE;
#line 99 "../src/history-button.vala"
	return result;
#line 350 "history-button.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 106 "../src/history-button.vala"
	return self ? g_object_ref (self) : NULL;
#line 358 "history-button.c"
}

static void
history_button_init_pixbuf (HistoryButton* self)
{
	GdkPixbuf* tmp_pixbuf = NULL;
	ThemeManager* _tmp0_;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GdkPixbuf* _tmp4_;
#line 101 "../src/history-button.vala"
	g_return_if_fail (self != NULL);
#line 103 "../src/history-button.vala"
	_tmp0_ = self->priv->_theme_manager;
#line 103 "../src/history-button.vala"
	_tmp1_ = theme_manager_get_pb_tileset_raw (_tmp0_);
#line 103 "../src/history-button.vala"
	_tmp2_ = _tmp1_;
#line 103 "../src/history-button.vala"
	_tmp3_ = gdk_pixbuf_scale_simple (_tmp2_, self->priv->pixbuf_size * 6, self->priv->pixbuf_size, GDK_INTERP_BILINEAR);
#line 103 "../src/history-button.vala"
	tmp_pixbuf = _tmp3_;
#line 104 "../src/history-button.vala"
	if (tmp_pixbuf == NULL) {
#line 105 "../src/history-button.vala"
		g_assert_not_reached ();
#line 386 "history-button.c"
	}
#line 106 "../src/history-button.vala"
	_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (tmp_pixbuf, gdk_pixbuf_get_type (), GdkPixbuf));
#line 106 "../src/history-button.vala"
	_g_object_unref0 (self->priv->tileset_pixbuf);
#line 106 "../src/history-button.vala"
	self->priv->tileset_pixbuf = _tmp4_;
#line 101 "../src/history-button.vala"
	_g_object_unref0 (tmp_pixbuf);
#line 396 "history-button.c"
}

static gboolean
history_button_update_drawing (HistoryButton* self,
                               cairo_t* cr)
{
	gboolean result;
#line 109 "../src/history-button.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 109 "../src/history-button.vala"
	g_return_val_if_fail (cr != NULL, FALSE);
#line 111 "../src/history-button.vala"
	if (!self->priv->drawing_configured) {
#line 112 "../src/history-button.vala"
		result = FALSE;
#line 112 "../src/history-button.vala"
		return result;
#line 414 "history-button.c"
	}
#line 114 "../src/history-button.vala"
	history_button_draw_arrow (self, cr);
#line 115 "../src/history-button.vala"
	history_button_draw_piece (self, cr);
#line 116 "../src/history-button.vala"
	result = TRUE;
#line 116 "../src/history-button.vala"
	return result;
#line 424 "history-button.c"
}

static void
history_button_draw_arrow (HistoryButton* self,
                           cairo_t* cr)
{
#line 120 "../src/history-button.vala"
	g_return_if_fail (self != NULL);
#line 120 "../src/history-button.vala"
	g_return_if_fail (cr != NULL);
#line 122 "../src/history-button.vala"
	cairo_save (cr);
#line 124 "../src/history-button.vala"
	cairo_set_line_cap (cr, CAIRO_LINE_CAP_ROUND);
#line 125 "../src/history-button.vala"
	cairo_set_line_join (cr, CAIRO_LINE_JOIN_ROUND);
#line 127 "../src/history-button.vala"
	cairo_set_source_rgba (cr, 0.5, 0.5, 0.5, 1.0);
#line 128 "../src/history-button.vala"
	cairo_set_line_width (cr, 2.0);
#line 130 "../src/history-button.vala"
	cairo_translate (cr, (gdouble) self->priv->board_x, (gdouble) self->priv->board_y);
#line 131 "../src/history-button.vala"
	cairo_move_to (cr, self->priv->arrow_half_width, HISTORY_BUTTON_arrow_margin_top);
#line 132 "../src/history-button.vala"
	cairo_line_to (cr, 3.0 * self->priv->arrow_half_width, self->priv->drawing_height / 2.0);
#line 133 "../src/history-button.vala"
	cairo_line_to (cr, self->priv->arrow_half_width, self->priv->drawing_height - HISTORY_BUTTON_arrow_margin_top);
#line 134 "../src/history-button.vala"
	cairo_stroke (cr);
#line 136 "../src/history-button.vala"
	cairo_restore (cr);
#line 457 "history-button.c"
}

static void
history_button_draw_piece (HistoryButton* self,
                           cairo_t* cr)
{
	gint offset = 0;
	gint x = 0;
	gint y = 0;
	GdkPixbuf* _tmp0_;
#line 140 "../src/history-button.vala"
	g_return_if_fail (self != NULL);
#line 140 "../src/history-button.vala"
	g_return_if_fail (cr != NULL);
#line 143 "../src/history-button.vala"
	switch (self->priv->current_player) {
#line 143 "../src/history-button.vala"
		case PLAYER_HUMAN:
#line 476 "history-button.c"
		{
#line 145 "../src/history-button.vala"
			offset = 0;
#line 145 "../src/history-button.vala"
			break;
#line 482 "history-button.c"
		}
#line 143 "../src/history-button.vala"
		case PLAYER_OPPONENT:
#line 486 "history-button.c"
		{
#line 146 "../src/history-button.vala"
			offset = self->priv->pixbuf_size;
#line 146 "../src/history-button.vala"
			break;
#line 492 "history-button.c"
		}
#line 143 "../src/history-button.vala"
		case PLAYER_NOBODY:
#line 496 "history-button.c"
		{
#line 147 "../src/history-button.vala"
			offset = self->priv->pixbuf_size * 2;
#line 147 "../src/history-button.vala"
			break;
#line 502 "history-button.c"
		}
		default:
		{
#line 148 "../src/history-button.vala"
			g_assert_not_reached ();
#line 508 "history-button.c"
		}
	}
#line 151 "../src/history-button.vala"
	cairo_save (cr);
#line 152 "../src/history-button.vala"
	x = ((self->priv->board_x + self->priv->drawing_width) - HISTORY_BUTTON_pixbuf_margin) - self->priv->pixbuf_size;
#line 153 "../src/history-button.vala"
	y = self->priv->board_y + HISTORY_BUTTON_pixbuf_margin;
#line 154 "../src/history-button.vala"
	_tmp0_ = self->priv->tileset_pixbuf;
#line 154 "../src/history-button.vala"
	gdk_cairo_set_source_pixbuf (cr, _tmp0_, (gdouble) (x - offset), (gdouble) y);
#line 155 "../src/history-button.vala"
	cairo_rectangle (cr, (gdouble) x, (gdouble) y, (gdouble) self->priv->pixbuf_size, (gdouble) self->priv->pixbuf_size);
#line 157 "../src/history-button.vala"
	cairo_clip (cr);
#line 158 "../src/history-button.vala"
	cairo_paint (cr);
#line 159 "../src/history-button.vala"
	cairo_restore (cr);
#line 529 "history-button.c"
}

static ThemeManager*
history_button_get_theme_manager (HistoryButton* self)
{
	ThemeManager* result;
	ThemeManager* _tmp0_;
#line 26 "../src/history-button.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "../src/history-button.vala"
	_tmp0_ = self->priv->_theme_manager;
#line 26 "../src/history-button.vala"
	result = _tmp0_;
#line 26 "../src/history-button.vala"
	return result;
#line 545 "history-button.c"
}

static void
history_button_set_theme_manager (HistoryButton* self,
                                  ThemeManager* value)
{
	ThemeManager* _tmp0_;
#line 26 "../src/history-button.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/history-button.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 26 "../src/history-button.vala"
	_g_object_unref0 (self->priv->_theme_manager);
#line 26 "../src/history-button.vala"
	self->priv->_theme_manager = _tmp0_;
#line 561 "history-button.c"
}

static gboolean
_history_button_configure_drawing_gtk_widget_configure_event (GtkWidget* _sender,
                                                              GdkEventConfigure* event,
                                                              gpointer self)
{
	gboolean result;
	result = history_button_configure_drawing ((HistoryButton*) self);
#line 38 "../src/history-button.vala"
	return result;
#line 573 "history-button.c"
}

static gboolean
_history_button_update_drawing_gtk_widget_draw (GtkWidget* _sender,
                                                cairo_t* cr,
                                                gpointer self)
{
	gboolean result;
	result = history_button_update_drawing ((HistoryButton*) self, cr);
#line 39 "../src/history-button.vala"
	return result;
#line 585 "history-button.c"
}

static void
_history_button___lambda6_ (HistoryButton* self)
{
#line 41 "../src/history-button.vala"
	if (!self->priv->drawing_configured) {
#line 42 "../src/history-button.vala"
		return;
#line 595 "history-button.c"
	}
#line 43 "../src/history-button.vala"
	history_button_init_pixbuf (self);
#line 44 "../src/history-button.vala"
	if (self->priv->current_player != PLAYER_NOBODY) {
#line 601 "history-button.c"
		GtkDrawingArea* _tmp0_;
#line 45 "../src/history-button.vala"
		_tmp0_ = self->priv->drawing;
#line 45 "../src/history-button.vala"
		gtk_widget_queue_draw ((GtkWidget*) _tmp0_);
#line 607 "history-button.c"
	}
}

static void
__history_button___lambda6__theme_manager_theme_changed (ThemeManager* _sender,
                                                         gpointer self)
{
#line 40 "../src/history-button.vala"
	_history_button___lambda6_ ((HistoryButton*) self);
#line 617 "history-button.c"
}

static GObject *
history_button_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	HistoryButton * self;
	GtkDrawingArea* _tmp0_;
	GtkDrawingArea* _tmp1_;
	ThemeManager* _tmp2_;
#line 36 "../src/history-button.vala"
	parent_class = G_OBJECT_CLASS (history_button_parent_class);
#line 36 "../src/history-button.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 36 "../src/history-button.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_HISTORY_BUTTON, HistoryButton);
#line 38 "../src/history-button.vala"
	_tmp0_ = self->priv->drawing;
#line 38 "../src/history-button.vala"
	g_signal_connect_object ((GtkWidget*) _tmp0_, "configure-event", (GCallback) _history_button_configure_drawing_gtk_widget_configure_event, self, 0);
#line 39 "../src/history-button.vala"
	_tmp1_ = self->priv->drawing;
#line 39 "../src/history-button.vala"
	g_signal_connect_object ((GtkWidget*) _tmp1_, "draw", (GCallback) _history_button_update_drawing_gtk_widget_draw, self, 0);
#line 40 "../src/history-button.vala"
	_tmp2_ = self->priv->_theme_manager;
#line 40 "../src/history-button.vala"
	g_signal_connect_object (_tmp2_, "theme-changed", (GCallback) __history_button___lambda6__theme_manager_theme_changed, self, 0);
#line 36 "../src/history-button.vala"
	return obj;
#line 651 "history-button.c"
}

static void
history_button_class_init (HistoryButtonClass * klass,
                           gpointer klass_data)
{
#line 24 "../src/history-button.vala"
	history_button_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/history-button.vala"
	g_type_class_adjust_private_offset (klass, &HistoryButton_private_offset);
#line 24 "../src/history-button.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_history_button_get_property;
#line 24 "../src/history-button.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_history_button_set_property;
#line 24 "../src/history-button.vala"
	G_OBJECT_CLASS (klass)->constructor = history_button_constructor;
#line 24 "../src/history-button.vala"
	G_OBJECT_CLASS (klass)->finalize = history_button_finalize;
#line 24 "../src/history-button.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HISTORY_BUTTON_THEME_MANAGER_PROPERTY, history_button_properties[HISTORY_BUTTON_THEME_MANAGER_PROPERTY] = g_param_spec_object ("theme-manager", "theme-manager", "theme-manager", TYPE_THEME_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 24 "../src/history-button.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Four-in-a-row/ui/history-button.ui");
#line 24 "../src/history-button.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "stack", FALSE, HistoryButton_private_offset + G_STRUCT_OFFSET (HistoryButtonPrivate, stack));
#line 24 "../src/history-button.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "drawing", FALSE, HistoryButton_private_offset + G_STRUCT_OFFSET (HistoryButtonPrivate, drawing));
#line 678 "history-button.c"
}

static void
history_button_adaptative_widget_interface_init (AdaptativeWidgetIface * iface,
                                                 gpointer iface_data)
{
#line 24 "../src/history-button.vala"
	history_button_adaptative_widget_parent_iface = g_type_interface_peek_parent (iface);
#line 24 "../src/history-button.vala"
	iface->set_window_size = (void (*) (AdaptativeWidget*, AdaptativeWidgetWindowSize)) history_button_real_set_window_size;
#line 689 "history-button.c"
}

static void
history_button_instance_init (HistoryButton * self,
                              gpointer klass)
{
#line 24 "../src/history-button.vala"
	self->priv = history_button_get_instance_private (self);
#line 69 "../src/history-button.vala"
	self->priv->drawing_configured = FALSE;
#line 70 "../src/history-button.vala"
	self->priv->drawing_height = G_MININT;
#line 71 "../src/history-button.vala"
	self->priv->drawing_width = G_MININT;
#line 72 "../src/history-button.vala"
	self->priv->pixbuf_size = G_MININT;
#line 73 "../src/history-button.vala"
	self->priv->arrow_half_width = -DBL_MAX;
#line 74 "../src/history-button.vala"
	self->priv->board_x = G_MININT;
#line 75 "../src/history-button.vala"
	self->priv->board_y = G_MININT;
#line 139 "../src/history-button.vala"
	self->priv->current_player = PLAYER_NOBODY;
#line 24 "../src/history-button.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 716 "history-button.c"
}

static void
history_button_finalize (GObject * obj)
{
	HistoryButton * self;
#line 24 "../src/history-button.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_HISTORY_BUTTON, HistoryButton);
#line 26 "../src/history-button.vala"
	_g_object_unref0 (self->priv->_theme_manager);
#line 78 "../src/history-button.vala"
	_g_object_unref0 (self->priv->tileset_pixbuf);
#line 24 "../src/history-button.vala"
	G_OBJECT_CLASS (history_button_parent_class)->finalize (obj);
#line 731 "history-button.c"
}

static GType
history_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HistoryButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) history_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HistoryButton), 0, (GInstanceInitFunc) history_button_instance_init, NULL };
	static const GInterfaceInfo adaptative_widget_info = { (GInterfaceInitFunc) history_button_adaptative_widget_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType history_button_type_id;
	history_button_type_id = g_type_register_static (gtk_menu_button_get_type (), "HistoryButton", &g_define_type_info, 0);
	g_type_add_interface_static (history_button_type_id, TYPE_ADAPTATIVE_WIDGET, &adaptative_widget_info);
	HistoryButton_private_offset = g_type_add_instance_private (history_button_type_id, sizeof (HistoryButtonPrivate));
	return history_button_type_id;
}

GType
history_button_get_type (void)
{
	static volatile gsize history_button_type_id__once = 0;
	if (g_once_init_enter (&history_button_type_id__once)) {
		GType history_button_type_id;
		history_button_type_id = history_button_get_type_once ();
		g_once_init_leave (&history_button_type_id__once, history_button_type_id);
	}
	return history_button_type_id__once;
}

static void
_vala_history_button_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	HistoryButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_HISTORY_BUTTON, HistoryButton);
#line 24 "../src/history-button.vala"
	switch (property_id) {
#line 24 "../src/history-button.vala"
		case HISTORY_BUTTON_THEME_MANAGER_PROPERTY:
#line 24 "../src/history-button.vala"
		g_value_set_object (value, history_button_get_theme_manager (self));
#line 24 "../src/history-button.vala"
		break;
#line 774 "history-button.c"
		default:
#line 24 "../src/history-button.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/history-button.vala"
		break;
#line 780 "history-button.c"
	}
}

static void
_vala_history_button_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	HistoryButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_HISTORY_BUTTON, HistoryButton);
#line 24 "../src/history-button.vala"
	switch (property_id) {
#line 24 "../src/history-button.vala"
		case HISTORY_BUTTON_THEME_MANAGER_PROPERTY:
#line 24 "../src/history-button.vala"
		history_button_set_theme_manager (self, g_value_get_object (value));
#line 24 "../src/history-button.vala"
		break;
#line 800 "history-button.c"
		default:
#line 24 "../src/history-button.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/history-button.vala"
		break;
#line 806 "history-button.c"
	}
}

